## godot 3.5.1-stable

=== debian/changelog ===
godot (3.5.1-stable-2) unstable; urgency=medium

  * Team upload.

  * Adjusted build rules to link with libatomic on armel and riscv64.
    (Closes: #1019868)
  * Disabled building denoise module on platforms where OIDN fail to build.
    (Closes: #1031132)
  * Updated build dependencies based on feedback from lintian.
  * Adjusted d/copyright to list CC0 license for appstream metadata XML file.
  * Adjusted install rules to install both appstream metadata and XSD
    MIME rules.
  * Updated Standards-Version from 4.6.0 to 4.6.2.

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 14 Jun 2023 15:36:52 +0200

godot (3.5.1-stable-1) unstable; urgency=medium

  [ Federico Ceratto ]
  * New upstream release (Closes: #1019931)
  * Set supported architectures (Closes: #978567)
  * Update third-party libraries in d/copyright

  [ Dominik George ]
  * New upstream version
    + CVE-2021-26825/CVE-2021-26826 (Closes: #982593)
  * Bump Standards-Version (no changes needed)
  * Fixes to d/copyright
    + Fix invalid file patterns
    + Remove superfluous fiels (not in source tree anymore)

 -- Dominik George <natureshadow@debian.org>  Sat, 28 Jan 2023 23:38:55 +0100

=== debian/control ===
Source: godot
Section: devel
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Federico Ceratto <federico@debian.org>,
 Dominik George <natureshadow@debian.org>
Build-Depends: debhelper-compat (= 13),
 ca-certificates,
 libasound2-dev,
 libenet-dev,
 libfreetype-dev,
 libgl-dev,
 libglu1-mesa-dev,
 libopus-dev,
 libopusfile-dev,
 libpcre2-dev,
 libpng-dev,
 libpulse-dev,
 libsquish-dev,
 libssl-dev,
 libtheora-dev,
 libudev-dev,
 libvorbis-dev,
 libvpx-dev,
 libwebp-dev,
 libx11-dev,
 libxcursor-dev,
 libxi-dev,
 libxinerama-dev,
 libxrandr-dev,
 pkg-config,
 scons,
 zlib1g-dev
Standards-Version: 4.6.2
Homepage: https://godotengine.org
Vcs-Git: https://salsa.debian.org/debian/godot3.git
Vcs-Browser: https://salsa.debian.org/debian/godot3

Package: godot3
Architecture: amd64 arm64 armel armhf i386 ppc64el s390x
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: Full 2D and 3D game engine with editor
 Godot is an advanced, feature packed, multi-platform 2D and 3D game engine.
 It provides a huge set of common tools, so you can just focus on making
 your game without reinventing the wheel.

Package: godot3-runner
Architecture: amd64 arm64 armel armhf i386 ppc64el s390x
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: Godot game engine run-time
 Godot is an advanced, feature packed, multi-platform 2D and 3D game engine.
 This package allows games to be run from source or data-pack.

Package: godot3-server
Architecture: amd64 arm64 armel armhf i386 ppc64el s390x
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: Headless Godot game engine run-time
 Godot is an advanced, feature packed, multi-platform 2D and 3D game engine.
 This package provides a command-line only version of the program.

#Package: godot3-dev
#Architecture: all
#Depends: ${misc:Depends}, godot3 (>= ${source:Version})
#Description: Godot game engine - Development headers
# Godot is an advanced, feature packed, multi-platform 2D and 3D game engine.
# This package contains development headers for modules.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
BITS = $(shell dpkg-architecture -q DEB_TARGET_ARCH_BITS)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# Link with libatomic on archs where it is needed.
# See <URL: https://bugs.debian.org/1019868 >
ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),armel riscv64))
       export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
endif

# The denoise module depends on OIDN which is x86_64 only (in the
# vendored version).
# Godot's own logic to disable it on other arches is a bit brittle
# when it comes to cross-compiling currently.
# See https://github.com/godotengine/godot/issues/47344
ifneq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),amd64 i386 armel armhf))
       DISABLE_MODULES = module_denoise_enabled=no
endif

override_dh_clean:
	dh_clean
	scons -c
	find . -iname "*.gen.cpp" -delete
	find . -iname "*.gen.h" -delete
	find . -iname "*.pyc" -delete
	find . -iname ".a" -delete
	find . -iname ".o" -delete
	find . -iname ".scons_env.json" -delete
	find . -iname ".sconsign.dblite" -delete
	find . -name '*.o' -delete
	rm -rf .sconf_temp/
	rm -rf main/libmain.x11.opt.tools.64.a main/tests/libtests.x11.opt.tools.64.a
	rm -rf config.log .sconsign?.dblite
	rm -rf bin/
	rm -rf enet
	rm -rf freetype
	rm -rf libogg
	rm -rf libpng
	rm -rf libtheora
	rm -rf libvorbis
	rm -rf libvpx
	rm -rf libwebp
	rm -rf openssl
	rm -rf opus
	rm -rf pcre2
	rm -rf squish
	rm -rf zlib

include /usr/share/dpkg/architecture.mk  # provides DEB_HOST_ARCH_BITS

# bullet requires 2.88

SCONS_OPTIONS = bits=$(DEB_HOST_ARCH_BITS) \
	system_certs_path=/etc/ssl/certs/ca-certificates.crt \
	builtin_bullet=yes \
	builtin_enet=no \
	builtin_freetype=no \
	builtin_libogg=no \
	builtin_libpng=no \
	builtin_libtheora=no \
	builtin_libvorbis=no \
	builtin_libvpx=no \
	builtin_libwebp=no \
	builtin_openssl=no \
	builtin_opus=no \
	builtin_pcre2=no \
	builtin_squish=no \
	builtin_zlib=no \
	builtin_zstd=yes

%:
	dh $@

override_dh_auto_build:
	dh_auto_build
	scons platform=server tools=yes target=release_debug $(SCONS_OPTIONS) -j $(NUMJOBS) CCFLAGS="$(CXXFLAGS)" LINKFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS)" $(DISABLE_MODULES)
	scons platform=x11    tools=no  target=release       $(SCONS_OPTIONS) -j $(NUMJOBS) CCFLAGS="$(CXXFLAGS)" LINKFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS)" $(DISABLE_MODULES)
	scons platform=x11    tools=yes target=release_debug $(SCONS_OPTIONS) -j $(NUMJOBS) CCFLAGS="$(CXXFLAGS)" LINKFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS)" $(DISABLE_MODULES)

override_dh_auto_install:
	echo "Installing binaries for $(BITS) bits architecture"
	install -D -m 400 $(CURDIR)/bin/godot.x11.opt.tools.$(BITS)           $(CURDIR)/debian/godot3/usr/bin/godot3
	install -D -m 400 $(CURDIR)/bin/godot.x11.opt.$(BITS)                 $(CURDIR)/debian/godot3-runner/usr/bin/godot3-runner
	install -D -m 400 $(CURDIR)/bin/godot_server.x11.opt.tools.$(BITS) $(CURDIR)/debian/godot3-server/usr/bin/godot3-server
	install -D -m 444 $(CURDIR)/misc/dist/linux/org.godotengine.Godot.desktop  $(CURDIR)/debian/godot3/usr/share/applications/org.godotengine.Godot.desktop
	install -D -m 444 $(CURDIR)/misc/dist/linux/org.godotengine.Godot.appdata.xml $(CURDIR)/debian/godot3/usr/share/metainfo/org.godotengine.Godot.xml
	install -D -m 444 $(CURDIR)/misc/dist/linux/org.godotengine.Godot.xml $(CURDIR)/debian/godot3/usr/share/mime/packages/org.godotengine.Godot.xml
	install -D -m 644 $(CURDIR)/icon.svg                                       $(CURDIR)/debian/godot3/usr/share/pixmaps/godot.svg
	sed -i 's/^Exec=.*/Exec=godot3 -p %f/' $(CURDIR)/debian/godot3/usr/share/applications/org.godotengine.Godot.desktop
	dh_auto_install

## godot 3.5.2

=== SConstruct ===
#!/usr/bin/env python

EnsureSConsVersion(0, 98, 1)

# System
import atexit
import glob
import os
import pickle
import sys
import time
from collections import OrderedDict

# Local
import methods
import gles_builders
from platform_methods import run_in_subprocess

# scan possible build platforms

platform_list = []  # list of platforms
platform_opts = {}  # options for each platform
platform_flags = {}  # flags for each platform

active_platforms = []
active_platform_ids = []
platform_exporters = []
platform_apis = []

time_at_start = time.time()

for x in sorted(glob.glob("platform/*")):
    if not os.path.isdir(x) or not os.path.exists(x + "/detect.py"):
        continue
    tmppath = "./" + x

    sys.path.insert(0, tmppath)
    import detect

    if os.path.exists(x + "/export/export.cpp"):
        platform_exporters.append(x[9:])
    if os.path.exists(x + "/api/api.cpp"):
        platform_apis.append(x[9:])
    if detect.is_active():
        active_platforms.append(detect.get_name())
        active_platform_ids.append(x)
    if detect.can_build():
        x = x.replace("platform/", "")  # rest of world
        x = x.replace("platform\\", "")  # win32
        platform_list += [x]
        platform_opts[x] = detect.get_opts()
        platform_flags[x] = detect.get_flags()
    sys.path.remove(tmppath)
    sys.modules.pop("detect")

methods.save_active_platforms(active_platforms, active_platform_ids)

custom_tools = ["default"]

platform_arg = ARGUMENTS.get("platform", ARGUMENTS.get("p", False))

if platform_arg == "android":
    custom_tools = ["clang", "clang++", "as", "ar", "link"]
elif platform_arg == "javascript":
    # Use generic POSIX build toolchain for Emscripten.
    custom_tools = ["cc", "c++", "ar", "link", "textfile", "zip"]
elif os.name == "nt" and methods.get_cmdline_bool("use_mingw", False):
    custom_tools = ["mingw"]

# We let SCons build its default ENV as it includes OS-specific things which we don't
# want to have to pull in manually.
# Then we prepend PATH to make it take precedence, while preserving SCons' own entries.
env_base = Environment(tools=custom_tools)
env_base.PrependENVPath("PATH", os.getenv("PATH"))
env_base.PrependENVPath("PKG_CONFIG_PATH", os.getenv("PKG_CONFIG_PATH"))
if "TERM" in os.environ:  # Used for colored output.
    env_base["ENV"]["TERM"] = os.environ["TERM"]

env_base.disabled_modules = []
env_base.use_ptrcall = False
env_base.module_version_string = ""
env_base.msvc = False

env_base.__class__.disable_module = methods.disable_module

env_base.__class__.add_module_version_string = methods.add_module_version_string

env_base.__class__.add_source_files = methods.add_source_files
env_base.__class__.use_windows_spawn_fix = methods.use_windows_spawn_fix
env_base.__class__.split_lib = methods.split_lib

env_base.__class__.add_shared_library = methods.add_shared_library
env_base.__class__.add_library = methods.add_library
env_base.__class__.add_program = methods.add_program
env_base.__class__.CommandNoCache = methods.CommandNoCache
env_base.__class__.disable_warnings = methods.disable_warnings

env_base["x86_libtheora_opt_gcc"] = False
env_base["x86_libtheora_opt_vc"] = False

# avoid issues when building with different versions of python out of the same directory
env_base.SConsignFile(".sconsign{0}.dblite".format(pickle.HIGHEST_PROTOCOL))

# Build options

customs = ["custom.py"]

profile = ARGUMENTS.get("profile", "")
if profile:
    if os.path.isfile(profile):
        customs.append(profile)
    elif os.path.isfile(profile + ".py"):
        customs.append(profile + ".py")

opts = Variables(customs, ARGUMENTS)

# Target build options
opts.Add("p", "Platform (alias for 'platform')", "")
opts.Add("platform", "Target platform (%s)" % ("|".join(platform_list),), "")
opts.Add(BoolVariable("tools", "Build the tools (a.k.a. the Godot editor)", True))
opts.Add(EnumVariable("target", "Compilation target", "debug", ("debug", "release_debug", "release")))
opts.Add("arch", "Platform-dependent architecture (arm/arm64/x86/x64/mips/...)", "")
opts.Add(EnumVariable("bits", "Target platform bits", "default", ("default", "32", "64")))
opts.Add(EnumVariable("optimize", "Optimization type", "speed", ("speed", "size", "none")))
opts.Add(BoolVariable("production", "Set defaults to build Godot for use in production", False))
opts.Add(BoolVariable("use_lto", "Use link-time optimization", False))

# Components
opts.Add(BoolVariable("deprecated", "Enable deprecated features", True))
opts.Add(BoolVariable("minizip", "Enable ZIP archive support using minizip", True))
opts.Add(BoolVariable("xaudio2", "Enable the XAudio2 audio driver", False))
opts.Add("custom_modules", "A list of comma-separated directory paths containing custom modules to build.", "")
opts.Add(BoolVariable("custom_modules_recursive", "Detect custom modules recursively for each specified path.", True))

# Advanced options
opts.Add(BoolVariable("dev", "If yes, alias for verbose=yes warnings=extra werror=yes", False))
opts.Add(BoolVariable("fast_unsafe", "Enable unsafe options for faster rebuilds", False))
opts.Add(BoolVariable("compiledb", "Generate compilation DB (`compile_commands.json`) for external tools", False))
opts.Add(BoolVariable("verbose", "Enable verbose output for the compilation", False))
opts.Add(BoolVariable("progress", "Show a progress indicator during compilation", True))
opts.Add(EnumVariable("warnings", "Level of compilation warnings", "all", ("extra", "all", "moderate", "no")))
opts.Add(BoolVariable("werror", "Treat compiler warnings as errors", False))
opts.Add("extra_suffix", "Custom extra suffix added to the base filename of all generated binary files", "")
opts.Add(BoolVariable("vsproj", "Generate a Visual Studio solution", False))
opts.Add(
    BoolVariable(
        "split_libmodules",
        "Split intermediate libmodules.a in smaller chunks to prevent exceeding linker command line size (forced to True when using MinGW)",
        False,
    )
)
opts.Add(BoolVariable("disable_3d", "Disable 3D nodes for a smaller executable", False))
opts.Add(BoolVariable("disable_advanced_gui", "Disable advanced GUI nodes and behaviors", False))
opts.Add(BoolVariable("no_editor_splash", "Don't use the custom splash screen for the editor", True))
opts.Add("system_certs_path", "Use this path as SSL certificates default for editor (for package maintainers)", "")
opts.Add(BoolVariable("use_precise_math_checks", "Math checks use very precise epsilon (debug option)", False))
opts.Add(
    EnumVariable(
        "rids",
        "Server object management technique (debug option)",
        "pointers",
        ("pointers", "handles", "tracked_handles"),
    )
)

# Thirdparty libraries
opts.Add(BoolVariable("builtin_bullet", "Use the built-in Bullet library", True))
opts.Add(BoolVariable("builtin_certs", "Use the built-in SSL certificates bundles", True))
opts.Add(BoolVariable("builtin_embree", "Use the built-in Embree library", True))
opts.Add(BoolVariable("builtin_enet", "Use the built-in ENet library", True))
opts.Add(BoolVariable("builtin_freetype", "Use the built-in FreeType library", True))
opts.Add(BoolVariable("builtin_libogg", "Use the built-in libogg library", True))
opts.Add(BoolVariable("builtin_libpng", "Use the built-in libpng library", True))
opts.Add(BoolVariable("builtin_libtheora", "Use the built-in libtheora library", True))
opts.Add(BoolVariable("builtin_libvorbis", "Use the built-in libvorbis library", True))
opts.Add(BoolVariable("builtin_libvpx", "Use the built-in libvpx library", True))
opts.Add(BoolVariable("builtin_libwebp", "Use the built-in libwebp library", True))
opts.Add(BoolVariable("builtin_wslay", "Use the built-in wslay library", True))
opts.Add(BoolVariable("builtin_mbedtls", "Use the built-in mbedTLS library", True))
opts.Add(BoolVariable("builtin_miniupnpc", "Use the built-in miniupnpc library", True))
opts.Add(BoolVariable("builtin_opus", "Use the built-in Opus library", True))
opts.Add(BoolVariable("builtin_pcre2", "Use the built-in PCRE2 library", True))
opts.Add(BoolVariable("builtin_pcre2_with_jit", "Use JIT compiler for the built-in PCRE2 library", True))
opts.Add(BoolVariable("builtin_recast", "Use the built-in Recast library", True))
opts.Add(BoolVariable("builtin_rvo2", "Use the built-in RVO2 library", True))
opts.Add(BoolVariable("builtin_squish", "Use the built-in squish library", True))
opts.Add(BoolVariable("builtin_xatlas", "Use the built-in xatlas library", True))
opts.Add(BoolVariable("builtin_zlib", "Use the built-in zlib library", True))
opts.Add(BoolVariable("builtin_zstd", "Use the built-in Zstd library", True))

# Compilation environment setup
opts.Add("CXX", "C++ compiler")
opts.Add("CC", "C compiler")
opts.Add("LINK", "Linker")
opts.Add("CCFLAGS", "Custom flags for both the C and C++ compilers")
opts.Add("CFLAGS", "Custom flags for the C compiler")
opts.Add("CXXFLAGS", "Custom flags for the C++ compiler")
opts.Add("LINKFLAGS", "Custom flags for the linker")

# Update the environment to have all above options defined
# in following code (especially platform and custom_modules).
opts.Update(env_base)

# Platform selection: validate input, and add options.

selected_platform = ""

if env_base["platform"] != "":
    selected_platform = env_base["platform"]
elif env_base["p"] != "":
    selected_platform = env_base["p"]
else:
    # Missing `platform` argument, try to detect platform automatically
    if (
        sys.platform.startswith("linux")
        or sys.platform.startswith("dragonfly")
        or sys.platform.startswith("freebsd")
        or sys.platform.startswith("netbsd")
        or sys.platform.startswith("openbsd")
    ):
        selected_platform = "x11"
    elif sys.platform == "darwin":
        selected_platform = "osx"
    elif sys.platform == "win32":
        selected_platform = "windows"
    else:
        print("Could not detect platform automatically. Supported platforms:")
        for x in platform_list:
            print("\t" + x)
        print("\nPlease run SCons again and select a valid platform: platform=<string>")

    if selected_platform != "":
        print("Automatically detected platform: " + selected_platform)

if selected_platform == "macos":
    # Alias for forward compatibility.
    print('Platform "macos" is still called "osx" in Godot 3.x. Building for platform "osx".')
    selected_platform = "osx"

if selected_platform == "ios":
    # Alias for forward compatibility.
    print('Platform "ios" is still called "iphone" in Godot 3.x. Building for platform "iphone".')
    selected_platform = "iphone"

if selected_platform in ["linux", "bsd", "linuxbsd"]:
    if selected_platform == "linuxbsd":
        # Alias for forward compatibility.
        print('Platform "linuxbsd" is still called "x11" in Godot 3.x. Building for platform "x11".')
    # Alias for convenience.
    selected_platform = "x11"

# Make sure to update this to the found, valid platform as it's used through the buildsystem as the reference.
# It should always be re-set after calling `opts.Update()` otherwise it uses the original input value.
env_base["platform"] = selected_platform

# Add platform-specific options.
if selected_platform in platform_opts:
    for opt in platform_opts[selected_platform]:
        opts.Add(opt)

# Update the environment to take platform-specific options into account.
opts.Update(env_base)
env_base["platform"] = selected_platform  # Must always be re-set after calling opts.Update().

# Detect modules.
modules_detected = OrderedDict()
module_search_paths = ["modules"]  # Built-in path.

if env_base["custom_modules"]:
    paths = env_base["custom_modules"].split(",")
    for p in paths:
        try:
            module_search_paths.append(methods.convert_custom_modules_path(p))
        except ValueError as e:
            print(e)
            sys.exit(255)

for path in module_search_paths:
    if path == "modules":
        # Built-in modules don't have nested modules,

=== platform/android/java/nativeSrcsConfigs/CMakeLists.txt ===
# Non functional cmake build file used to provide Android Studio editor support to the project.
cmake_minimum_required(VERSION 3.6)
project(godot)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(GODOT_ROOT_DIR ../../../..)

# Get sources
file(GLOB_RECURSE SOURCES ${GODOT_ROOT_DIR}/*.c**)
file(GLOB_RECURSE HEADERS ${GODOT_ROOT_DIR}/*.h**)

add_executable(${PROJECT_NAME} ${SOURCES} ${HEADERS})
target_include_directories(${PROJECT_NAME}
        SYSTEM PUBLIC
        ${GODOT_ROOT_DIR}
        ${GODOT_ROOT_DIR}/modules/gdnative/include)

add_definitions(-DUNIX_ENABLED -DANDROID_ENABLED)

## godot 3.5.2-stable

=== debian/changelog ===
godot (3.5.2-stable-2build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:52:42 +1100

godot (3.5.2-stable-2build3) noble; urgency=medium

  * No-change rebuild against libvpx9

 -- Lukas Märdian <slyon@ubuntu.com>  Tue, 19 Mar 2024 10:44:04 +0100

godot (3.5.2-stable-2build2) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 06:46:36 +0000

godot (3.5.2-stable-2build1) noble; urgency=medium

  * Rebuild against new libvpx8.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 17 Nov 2023 19:12:36 +0100

godot (3.5.2-stable-2) unstable; urgency=medium

  * Team upload.

  * Adjusted d/rules scons call to try to get the build working on
    ppc64le.

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 21 Jun 2023 16:37:46 +0200

godot (3.5.2-stable-1) unstable; urgency=medium

  * Team upload.

  * Added d/gbp.conf to enforce use of pristine-tar.
  * New upstream version 3.5.2-stable.
  * Disable modules raycast and lightmapper_cpu on s390x (Closes: #1037985).

 -- Petter Reinholdtsen <pere@debian.org>  Thu, 15 Jun 2023 18:51:07 +0200

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,10 @@
 #!/usr/bin/make -f
 export DH_VERBOSE = 1
 NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+
+# Force suffix on binaries to avoid special treatment of riscv64, ppc64le, ppc64,
+# ppcle and ppc in ./platform/x11/detect.py.  Without this, the install calls below
+# fail to find the expected binaries.
 BITS = $(shell dpkg-architecture -q DEB_TARGET_ARCH_BITS)
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
@@ -18,13 +22,15 @@
 # Godot's own logic to disable it on other arches is a bit brittle
 # when it comes to cross-compiling currently.
 # See https://github.com/godotengine/godot/issues/47344
+# The embree library used by raycast and lightmapper_cpu modules do
+# not build on s390x, disable on archs where it is not already building.
 ifneq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),amd64 i386 armel armhf))
-       DISABLE_MODULES = module_denoise_enabled=no
+       DISABLE_MODULES = module_denoise_enabled=no module_embree_enabled=no module_raycast_enabled=no module_lightmapper_cpu_enabled=no
 endif
 
 override_dh_clean:
 	dh_clean
-	scons -c
+	scons -c arch=$(BITS)
 	find . -iname "*.gen.cpp" -delete
 	find . -iname "*.gen.h" -delete
 	find . -iname "*.pyc" -delete
@@ -78,9 +84,9 @@
 
 override_dh_auto_build:
 	dh_auto_build
-	scons platform=server tools=yes target=release_debug $(SCONS_OPTIONS) -j $(NUMJOBS) CCFLAGS="$(CXXFLAGS)" LINKFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS)" $(DISABLE_MODULES)
-	scons platform=x11    tools=no  target=release       $(SCONS_OPTIONS) -j $(NUMJOBS) CCFLAGS="$(CXXFLAGS)" LINKFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS)" $(DISABLE_MODULES)
-	scons platform=x11    tools=yes target=release_debug $(SCONS_OPTIONS) -j $(NUMJOBS) CCFLAGS="$(CXXFLAGS)" LINKFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS)" $(DISABLE_MODULES)
+	scons arch=$(BITS) platform=server tools=yes target=release_debug $(SCONS_OPTIONS) -j $(NUMJOBS) CCFLAGS="$(CXXFLAGS)" LINKFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS)" $(DISABLE_MODULES)
+	scons arch=$(BITS) platform=x11    tools=no  target=release       $(SCONS_OPTIONS) -j $(NUMJOBS) CCFLAGS="$(CXXFLAGS)" LINKFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS)" $(DISABLE_MODULES)
+	scons arch=$(BITS) platform=x11    tools=yes target=release_debug $(SCONS_OPTIONS) -j $(NUMJOBS) CCFLAGS="$(CXXFLAGS)" LINKFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS)" $(DISABLE_MODULES)
 
 override_dh_auto_install:
 	echo "Installing binaries for $(BITS) bits architecture"

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/godot-$1\.tar\.gz/ https://github.com/godotengine/godot/tags .*/v?(\d\S*)\.tar\.gz

## godot 3.6+ds

=== SConstruct ===
--- 
+++ 
@@ -14,6 +14,7 @@
 # Local
 import methods
 import gles_builders
+import scu_builders
 from platform_methods import run_in_subprocess
 
 # scan possible build platforms
@@ -94,6 +95,7 @@
 env_base.__class__.add_program = methods.add_program
 env_base.__class__.CommandNoCache = methods.CommandNoCache
 env_base.__class__.disable_warnings = methods.disable_warnings
+env_base.__class__.force_optimization_on_debug = methods.force_optimization_on_debug
 
 env_base["x86_libtheora_opt_gcc"] = False
 env_base["x86_libtheora_opt_vc"] = False
@@ -123,12 +125,13 @@
 opts.Add(EnumVariable("bits", "Target platform bits", "default", ("default", "32", "64")))
 opts.Add(EnumVariable("optimize", "Optimization type", "speed", ("speed", "size", "none")))
 opts.Add(BoolVariable("production", "Set defaults to build Godot for use in production", False))
-opts.Add(BoolVariable("use_lto", "Use link-time optimization", False))
+opts.Add(EnumVariable("lto", "Link-time optimization (production builds)", "none", ("none", "auto", "thin", "full")))
 
 # Components
 opts.Add(BoolVariable("deprecated", "Enable deprecated features", True))
 opts.Add(BoolVariable("minizip", "Enable ZIP archive support using minizip", True))
 opts.Add(BoolVariable("xaudio2", "Enable the XAudio2 audio driver", False))
+opts.Add(BoolVariable("disable_exceptions", "Force disabling exception handling code", True))
 opts.Add("custom_modules", "A list of comma-separated directory paths containing custom modules to build.", "")
 opts.Add(BoolVariable("custom_modules_recursive", "Detect custom modules recursively for each specified path.", True))
 
@@ -151,9 +154,11 @@
 )
 opts.Add(BoolVariable("disable_3d", "Disable 3D nodes for a smaller executable", False))
 opts.Add(BoolVariable("disable_advanced_gui", "Disable advanced GUI nodes and behaviors", False))
+opts.Add(BoolVariable("modules_enabled_by_default", "If no, disable all modules except ones explicitly enabled", True))
 opts.Add(BoolVariable("no_editor_splash", "Don't use the custom splash screen for the editor", True))
 opts.Add("system_certs_path", "Use this path as SSL certificates default for editor (for package maintainers)", "")
 opts.Add(BoolVariable("use_precise_math_checks", "Math checks use very precise epsilon (debug option)", False))
+opts.Add(BoolVariable("scu_build", "Use single compilation unit build", False))
 opts.Add(
     EnumVariable(
         "rids",
@@ -249,6 +254,11 @@
     # Alias for convenience.
     selected_platform = "x11"
 
+if selected_platform == "web":
+    # Alias for forward compatibility.
+    print('Platform "web" is still called "javascript" in Godot 3.x. Building for platform "javascript".')
+    selected_platform = "javascript"
+
 # Make sure to update this to the found, valid platform as it's used through the buildsystem as the reference.
 # It should always be re-set after calling `opts.Update()` otherwise it uses the original input value.
 env_base["platform"] = selected_platform
@@ -258,23 +268,3 @@
     for opt in platform_opts[selected_platform]:
         opts.Add(opt)
 
-# Update the environment to take platform-specific options into account.
-opts.Update(env_base)
-env_base["platform"] = selected_platform  # Must always be re-set after calling opts.Update().
-
-# Detect modules.
-modules_detected = OrderedDict()
-module_search_paths = ["modules"]  # Built-in path.
-
-if env_base["custom_modules"]:
-    paths = env_base["custom_modules"].split(",")
-    for p in paths:
-        try:
-            module_search_paths.append(methods.convert_custom_modules_path(p))
-        except ValueError as e:
-            print(e)
-            sys.exit(255)
-
-for path in module_search_paths:
-    if path == "modules":
-        # Built-in modules don't have nested modules,

=== debian/changelog ===
godot (3.6+ds-2ubuntu0.1) plucky-security; urgency=medium

  * SECURITY UPDATE: Crash due to double free of variable
    - debian/patches/CVE-2019-2126.patch: Avoid double free in 
      ContentEnconding
    - CVE-2019-2126

 -- John Breton <john.breton@canonical.com>  Tue, 17 Jun 2025 07:48:28 -0400

godot (3.6+ds-2) unstable; urgency=medium

  [ Travis Wrightsman ]
  * Allow autopkgtest to fail on some architectures
  * Remove after_script workarounds after upstream fix

 -- Otto Kekäläinen <otto@debian.org>  Mon, 30 Dec 2024 21:13:41 -0800

godot (3.6+ds-1) unstable; urgency=medium

  [ Travis Wrightsman ]
  * New upstream version 3.6+ds (Related: #1070845)
  * Add autopkgtests
  * Migrate metainfo and icon to modern freedesktop paths
  * Install godot3 man page
  * Unvendor as many dependencies as currently possible
  * Replace custom_build suffix with Debian version
  * Namespace everything to major version 3
  * Namespace StartupWMClass to major version too
  * Add myself to d/copyright
  * Update VCS URL salsa.debian.org/games-team/godot3

  [ Otto Kekäläinen ]
  * Enable Salsa CI to improve quality assurance prior to upload
  * Add myself to copyright and uploader while sponsoring Travis' work

 -- Otto Kekäläinen <otto@debian.org>  Mon, 16 Dec 2024 16:13:02 -0800

=== debian/control ===
Source: godot
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Otto Kekäläinen <otto@debian.org>,
 Travis Wrightsman <travis@wrightsman.org>,
 Federico Ceratto <federico@debian.org>,
 Dominik George <natureshadow@debian.org>,
Build-Depends:
 ca-certificates,
 debhelper-compat (= 13),
 libasound2-dev,
 libbullet-dev,
 libenet-dev,
 libfreetype-dev,
 libgl-dev,
 libglu1-mesa-dev,
 libminiupnpc-dev,
 libopus-dev,
 libopusfile-dev,
 libpcre2-dev,
 libpng-dev,
 libpulse-dev,
 librecast-dev,
 libsquish-dev,
 libtheora-dev,
 libudev-dev,
 libvorbis-dev,
 libvpx-dev,
 libwebp-dev,
 libwslay-dev,
 libx11-dev,
 libxcursor-dev,
 libxi-dev,
 libxinerama-dev,
 libxrandr-dev,
 libzstd-dev,
 pkgconf,
 scons,
 zlib1g-dev,
Standards-Version: 4.6.2
Homepage: https://godotengine.org
Vcs-Git: https://salsa.debian.org/games-team/godot3.git
Vcs-Browser: https://salsa.debian.org/games-team/godot3

Package: godot3
Architecture: amd64 arm64 armel armhf i386 ppc64el s390x
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Full 2D and 3D game engine with editor
 Godot is an advanced, feature packed, multi-platform 2D and 3D game engine.
 It provides a huge set of common tools, so you can just focus on making
 your game without reinventing the wheel.

Package: godot3-runner
Architecture: amd64 arm64 armel armhf i386 ppc64el s390x
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Godot game engine run-time
 Godot is an advanced, feature packed, multi-platform 2D and 3D game engine.
 This package allows games to be run from source or data-pack.

Package: godot3-server
Architecture: amd64 arm64 armel armhf i386 ppc64el s390x
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Headless Godot game engine run-time
 Godot is an advanced, feature packed, multi-platform 2D and 3D game engine.
 This package provides a command-line only version of the program.

=== debian/tests/control ===
Tests: editor
Depends:
 godot3,
 xauth,
 xvfb,
Restrictions: allow-stderr, flaky

Tests: server
Depends:
 godot3-server,
Restrictions: allow-stderr

## godot 3.6+ds1

=== SConstruct ===
--- 
+++ 
@@ -152,6 +152,7 @@
         False,
     )
 )
+opts.Add("import_env_vars", "A comma-separated list of environment variables to copy from the outer environment.", "")
 opts.Add(BoolVariable("disable_3d", "Disable 3D nodes for a smaller executable", False))
 opts.Add(BoolVariable("disable_advanced_gui", "Disable advanced GUI nodes and behaviors", False))
 opts.Add(BoolVariable("modules_enabled_by_default", "If no, disable all modules except ones explicitly enabled", True))
@@ -206,6 +207,12 @@
 # in following code (especially platform and custom_modules).
 opts.Update(env_base)
 
+# Copy custom environment variables if set.
+if env_base["import_env_vars"]:
+    for env_var in str(env_base["import_env_vars"]).split(","):
+        if env_var in os.environ:
+            env_base["ENV"][env_var] = os.environ[env_var]
+
 # Platform selection: validate input, and add options.
 
 selected_platform = ""
@@ -260,11 +267,3 @@
     selected_platform = "javascript"
 
 # Make sure to update this to the found, valid platform as it's used through the buildsystem as the reference.
-# It should always be re-set after calling `opts.Update()` otherwise it uses the original input value.
-env_base["platform"] = selected_platform
-
-# Add platform-specific options.
-if selected_platform in platform_opts:
-    for opt in platform_opts[selected_platform]:
-        opts.Add(opt)
-

=== debian/changelog ===
godot (3.6+ds1-2~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 23 Jan 2025 06:17:46 -0800

=== debian/control ===
Source: godot
Section: devel
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Otto Kekäläinen <otto@debian.org>,
           Travis Wrightsman <travis@wrightsman.org>,
           Federico Ceratto <federico@debian.org>,
           Dominik George <natureshadow@debian.org>
Build-Depends: ca-certificates,
               debhelper-compat (= 13),
               libasound2-dev,
               libbullet-dev,
               libenet-dev,
               libfreetype-dev,
               libgl-dev,
               libglu1-mesa-dev,
               libminiupnpc-dev,
               libopus-dev,
               libopusfile-dev,
               libpcre2-dev,
               libpng-dev,
               libpulse-dev,
               librecast-dev,
               libsquish-dev,
               libtheora-dev,
               libudev-dev,
               libvorbis-dev,
               libvpx-dev,
               libwebp-dev,
               libwslay-dev,
               libx11-dev,
               libxcursor-dev,
               libxi-dev,
               libxinerama-dev,
               libxrandr-dev,
               libzstd-dev,
               pkgconf,
               scons,
               zlib1g-dev
Standards-Version: 4.6.2
Homepage: https://godotengine.org
Vcs-Git: https://salsa.debian.org/games-team/godot3.git
Vcs-Browser: https://salsa.debian.org/games-team/godot3

Package: godot3
Architecture: amd64 arm64 armel armhf i386 ppc64el s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Full 2D and 3D game engine with editor
 Godot is an advanced, feature packed, multi-platform 2D and 3D game engine.
 It provides a huge set of common tools, so you can just focus on making
 your game without reinventing the wheel.

Package: godot3-runner
Architecture: amd64 arm64 armel armhf i386 ppc64el s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Godot game engine run-time
 Godot is an advanced, feature packed, multi-platform 2D and 3D game engine.
 This package allows games to be run from source or data-pack.

Package: godot3-server
Architecture: amd64 arm64 armel armhf i386 ppc64el s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Headless Godot game engine run-time
 Godot is an advanced, feature packed, multi-platform 2D and 3D game engine.
 This package provides a command-line only version of the program.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))

# Force suffix on binaries to avoid special treatment of riscv64, ppc64le, ppc64,
# ppcle and ppc in ./platform/x11/detect.py.  Without this, the install calls below
# fail to find the expected binaries.
BITS = $(shell dpkg-architecture -q DEB_TARGET_ARCH_BITS)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# Link with libatomic on archs where it is needed.
# See <URL: https://bugs.debian.org/1019868 >
ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),armel riscv64))
       export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
endif

# The denoise module depends on OIDN which is x86_64 only (in the
# vendored version).
# Godot's own logic to disable it on other arches is a bit brittle
# when it comes to cross-compiling currently.
# See https://github.com/godotengine/godot/issues/47344
# The embree library used by raycast and lightmapper_cpu modules do
# not build on s390x, disable on archs where it is not already building.
ifneq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),amd64 i386 armel armhf))
       DISABLE_MODULES = module_denoise_enabled=no module_embree_enabled=no module_raycast_enabled=no module_lightmapper_cpu_enabled=no
endif

# replace "custom_build" with more useful Debian version info
include /usr/share/dpkg/pkg-info.mk  # provides DEB_VERSION
export BUILD_NAME = debian${DEB_VERSION}

include /usr/share/dpkg/architecture.mk  # provides DEB_HOST_ARCH_BITS

# Godot 3.x requires embree 3.x and mbedtls 2.x [0], but embree 4.x and
# mbedtls 3.x are currently all that is available in unstable. rvo2 and
# xatlas are not available within Debian.
# [0] https://github.com/godotengine/godot/issues/100390
SCONS_OPTIONS = bits=$(DEB_HOST_ARCH_BITS) \
	--jobs=8 \
	import_env_vars=CCACHE_DIR \
	CC="$(CC)" \
	CXX="$(CXX)" \
	CCFLAGS="$(CPPFLAGS)" \
	CFLAGS="$(CFLAGS)" \
	CXXFLAGS="$(CXXFLAGS)" \
	LINKFLAGS="$(LDFLAGS)" \
	builtin_bullet=no \
	builtin_certs=no \
	system_certs_path=/etc/ssl/certs/ca-certificates.crt \
	builtin_embree=yes \
	builtin_enet=no \
	builtin_freetype=no \
	builtin_libogg=no \
	builtin_libpng=no \
	builtin_libtheora=no \
	builtin_libvorbis=no \
	builtin_libvpx=no \
	builtin_libwebp=no \
	builtin_wslay=no \
	builtin_mbedtls=yes \
	builtin_miniupnpc=no \
	builtin_opus=no \
	builtin_pcre2=no \
	builtin_recast=no \
	builtin_rvo2=yes \
	builtin_squish=no \
	builtin_xatlas=yes \
	builtin_zlib=no \
	builtin_zstd=no \
	use_static_cpp=no \
	verbose=yes

%:
	dh $@

override_dh_clean:
	scons -c arch=$(BITS) platform=server tools=yes target=release_debug $(SCONS_OPTIONS) $(DISABLE_MODULES)
	scons -c arch=$(BITS) platform=x11    tools=no  target=release       $(SCONS_OPTIONS) $(DISABLE_MODULES)
	scons -c arch=$(BITS) platform=x11    tools=yes target=release_debug $(SCONS_OPTIONS) $(DISABLE_MODULES)
	dh_clean

override_dh_auto_build:
	dh_auto_build
	scons arch=$(BITS) platform=server tools=yes target=release_debug $(SCONS_OPTIONS) $(DISABLE_MODULES)
	scons arch=$(BITS) platform=x11    tools=no  target=release       $(SCONS_OPTIONS) $(DISABLE_MODULES)
	scons arch=$(BITS) platform=x11    tools=yes target=release_debug $(SCONS_OPTIONS) $(DISABLE_MODULES)

override_dh_auto_install:
	echo "Installing binaries for $(BITS) bits architecture"
	install -D -m 400 $(CURDIR)/bin/godot.x11.opt.tools.$(BITS) $(CURDIR)/debian/godot3/usr/bin/godot3
	install -D -m 400 $(CURDIR)/bin/godot.x11.opt.$(BITS) $(CURDIR)/debian/godot3-runner/usr/bin/godot3-runner
	install -D -m 400 $(CURDIR)/bin/godot_server.x11.opt.tools.$(BITS) $(CURDIR)/debian/godot3-server/usr/bin/godot3-server
	install -D -m 444 $(CURDIR)/misc/dist/linux/org.godotengine.Godot.desktop $(CURDIR)/debian/godot3/usr/share/applications/org.godotengine.Godot3.desktop
	install -D -m 444 $(CURDIR)/misc/dist/linux/org.godotengine.Godot.appdata.xml $(CURDIR)/debian/godot3/usr/share/metainfo/org.godotengine.Godot3.metainfo.xml
	install -D -m 444 $(CURDIR)/misc/dist/linux/org.godotengine.Godot.xml $(CURDIR)/debian/godot3/usr/share/mime/packages/org.godotengine.Godot3.xml
	install -D -m 644 $(CURDIR)/icon.svg $(CURDIR)/debian/godot3/usr/share/icons/hicolor/scalable/apps/godot3.svg
	install -D -m 444 $(CURDIR)/misc/dist/linux/godot.6 $(CURDIR)/debian/godot3/usr/share/man/man6/godot3.6
	install -D -m 444 $(CURDIR)/misc/dist/linux/godot.6 $(CURDIR)/debian/godot3-runner/usr/share/man/man6/godot3-runner.6
	sed -i 's/godot3/godot3-runner/' $(CURDIR)/debian/godot3-runner/usr/share/man/man6/godot3-runner.6
	install -D -m 444 $(CURDIR)/misc/dist/linux/godot.6 $(CURDIR)/debian/godot3-server/usr/share/man/man6/godot3-server.6
	sed -i 's/godot3/godot3-server/' $(CURDIR)/debian/godot3-server/usr/share/man/man6/godot3-server.6
	dh_auto_install

# No dbgsym packages:
override_dh_strip:
	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
	dh_strip --no-automatic-dbgsym

=== debian/tests/control ===
Tests: editor
Depends: godot3, xauth, xvfb
Restrictions: allow-stderr, flaky

Tests: server
Depends: godot3-server
Restrictions: allow-stderr
